
using System.IO;
using System.Runtime.Serialization;

namespace SECOM.Common.Integration.Models
{
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class Organization
    {
        public Organization()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Organization" /> class.
        /// </summary>
        /// <param name="Country">Country (required).</param>
        /// <param name="Email">Email (required).</param>
        /// <param name="Mrn">The Maritime Resource Name (required).</param>
        /// <param name="Name">The name of the organization (required).</param>
        public Organization(string Country = null, string Email = null, string Mrn = null, string Name = null)
        {
            // to ensure "Country" is required (not null)
            if (Country == null)
            {
                throw new InvalidDataException("Country is a required property for Organization and cannot be null");
            }
            else
            {
                this.Country = Country;
            }

            this.Email = Email;

            // to ensure "Mrn" is required (not null)
            if (Mrn == null)
            {
                throw new InvalidDataException("Mrn is a required property for Organization and cannot be null");
            }
            else
            {
                this.Mrn = Mrn;
            }
            // to ensure "Name" is required (not null)
            if (Name == null)
            {
                throw new InvalidDataException("Name is a required property for Organization and cannot be null");
            }
            else
            {
                this.Name = Name;
            }
            
        }

        /// <summary>
        /// Gets or Sets Country
        /// </summary>
        [DataMember(Name="country")]
        public string Country { get; set; }

        /// <summary>
        /// Gets or Sets Email
        /// </summary>
        [DataMember(Name="email")]
        public string Email { get; set; }

        /// <summary>
        /// The Maritime Resource Name
        /// </summary>
        /// <value>The Maritime Resource Name</value>
        [DataMember(Name="mrn")]
        public string Mrn { get; set; }

        /// <summary>
        /// The name of the organization
        /// </summary>
        /// <value>The name of the organization</value>
        [DataMember(Name="name")]
        public string Name { get; set; }

    }
}
