﻿using System.ComponentModel.DataAnnotations;

namespace SECOM.Common.Models.Public
{
    public class AccessRequestObject
    {
        /// <summary>
        /// Human readable reason for requesting access
        /// </summary>
        [Required]
        public string Reason { get; set; }

        /// <summary>
        /// Machine readable reason for requesting access
        /// </summary>
        [Required]
        public ReasonEnum ReasonEnum { get; set; }

        /// <summary>
        /// Data container Type requested, e.g. S100_DATASET
        ///  </summary>
        public ContainerTypeEnum? ContainerType { get; set; }

        /// <summary>
        /// Data product type name requested, e.g. S122
        /// </summary>
        public Secom_DataProductTypeEnum? DataProductType { get; set; }

        /// <summary>
        /// Reference to the data requested access to
        /// </summary>
        public string DataReference { get; set; }

        /// <summary>
        /// S-100 based Product type version requested, e.g. 1.0.0
        /// </summary>
        public string ProductVersion { get; set; }


    }
}