﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace SECOM.Common.Models.Public
{
    public class CapabilityResponseObject
    {
        [Required]
        public List<CapabilityObject> Capability { get; set; }

    }

    public class CapabilityObject
    {
        /// <summary>
        /// Data product type name supported, e.g. S122
        /// </summary>
        [Required]
        public Secom_DataProductTypeEnum DataProductType { get; set; }

        [Required]
        public ContainerTypeEnum ContainerType { get; set; }
        /// <summary>
        /// URL to schema for the payload (product)
        /// </summary>
        [Required]
        public string ProductSchemaUrl { get; set; }

        [Required]
        public string ServiceVersion { get; set; }

        /// <summary>
        /// List of service interfaces implemented with the payload (product) in focus
        /// </summary>
        [Required]
        public ImplementedInterfaces ImplementedInterfaces { get; set; }
    }
}
