﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace SECOM.Common.Models.Public
{
    public class DataResponseObject
    {
        /// <summary>
        /// The data according to Product Specification embedded in JSON.The data may be encrypted and signed.
        /// </summary>
        [Required]
        public byte[] Data { get; set; }

        /// <summary>
        /// Service exchange metadata with signature, id etc.
        /// </summary>
        [Required]
        public ExchangeMetadata ExchangeMetadata { get; set; }

        /// <summary>
        /// Indicates request for acknowledgement.
        /// </summary>
        [Required]
        public AckRequestEnum AckRequest { get; set; }
    }
}
