﻿using System.ComponentModel.DataAnnotations;

namespace SECOM.Common.Models.Public
{
    [System.Serializable]
    public class DigitalSignatureValueObject
    {
        /// <summary>
        /// Claimed Thumbprint for Signed Root Key (X.509 Certificate)
        /// </summary>
        public string PublicRootCertificateThumbprint { get; set; }

        /// <summary>
        /// (S100) Public Key for claimed identity
        /// </summary>
        ///         
        [Required]
        public string PublicCertificate { get; set; }

        /// <summary>
        /// (S100) The digital signature in HEX format as one row, no trailing return/new line
        /// </summary>
        [Required]
        public string DigitalSignature { get; set; }
    }
}