﻿using System;
using System.ComponentModel.DataAnnotations;

namespace SECOM.Common.Models.Public
{
    [Serializable]
    public class EnvelopeAckObject
    {
        /// <summary>
        /// Creation time for the acknowledgement
        /// </summary>
        [Required]
        public DateTime CreatedAt { get; set; }

        /// <summary>
        /// The public certificate of the sender. used to verify the envelope signature
        /// </summary>
        [Required]
        public string EnvelopeCertificate { get; set; }

        /// <summary>
        /// Claimed Thumbprint for Signed Root Key (X.509 Certificate)
        /// </summary>
        [Required]
        public string EnvelopeRootCertificateThumbprint { get; set; }

        /// <summary>
        /// Reference identifier given in upload
        /// </summary>
        [Required]
        public Guid TransactionIdentifier { get; set; }

        /// <summary>
        /// Type of acknownledgement
        /// </summary>
        [Required]
        public AckTypeEnum AckType { get; set; }

        /// <summary>
        /// Information details if error
        /// </summary>
        public NackTypeEnum? NackType { get; set; }

        /// <summary>
        /// Time stamp when the envelope is signed
        /// </summary>
        [Required]
        public DateTime EnvelopeSignatureTime { get; set; }

    }
}
