﻿using System;

namespace SECOM.Common.Models.Public
{
    public class SubscriptionRequestObject
    {
        /// <summary>
        /// Data Type requested 
        /// </summary>
        public ContainerTypeEnum? ContainerType { get; set; }


        /// <summary>
        /// Geometry condition for geolocated information objects
        /// </summary>
        public string Geometry { get; set; }


        /// <summary>
        /// Code of defined object
        /// </summary>
        public string Unlocode { get; set; }

        /// <summary>
        /// Data product type name requested, e.g. S-122
        /// </summary>
        public Secom_DataProductTypeEnum? DataProductType { get; set; }

        /// <summary>
        /// S-100 based Product type version requested, e.g. 1.0.0
        /// </summary>
        public string ProductVersion { get; set; }

        /// <summary>
        /// Reference to data
        /// </summary>
        public string DataReference { get; set; }
    }
}
