﻿using SECOM.Common.Schema;
using SECOM.Common.Utils;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Xml;

namespace SECOM.Common.Services
{
    public class SchemaValidationService
    {
        private static object _lockobject = new object();
        private string _valResult;
        private static SchemaValidator _validator { get; set; }
        public SchemaValidationService()
        {
            lock(_lockobject)
            {
                if(_validator == null)
                {
                    var schemaAssembly = Assembly.GetAssembly(typeof(SECOM.Common.Schema.Schema));
                    var names = schemaAssembly.GetManifestResourceNames();
                    names = names.OrderBy(x => x).ToArray();

                    _validator = new SchemaValidator(schemaAssembly, names.ToList());
                }
            }
        }

        public void ValidateS124Xml(string msg)
        {
            _valResult = null;
            if (msg == null)
            {
                throw new Secom_SchemaValidationException("S-124 message is null. Not a valid message.");
            }

            _valResult = _validator.ValidateXML(msg);

            if (!string.IsNullOrEmpty(_valResult))
            {
                throw new Secom_SchemaValidationException("S-124 message does not validate ok. Details: " + _valResult);
            }
        }

        public void ValidateRtzXml(string msg)
        {
            _valResult = null;
            if (msg == null)
            {
                throw new Secom_SchemaValidationException("Message is null. Not a valid message.");
            }

            _valResult = _validator.ValidateXML(msg, true);

            if (!string.IsNullOrEmpty(_valResult))
            {
                throw new Secom_SchemaValidationException("Message does not validate ok. Details: " + _valResult);
            }
        }
    }
}
