﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;

namespace SECOM.Common.Utils
{
    public class GeoHelper
    {
        private Route _route;
        public Route Route
        {
            get
            {
                return _route;
            }
            set
            {
                if (_route == value)
                    return;
                _route = value;
            }
        }
        private Waypoints _waypoints { get; set; }
        public Waypoints Waypoints
        {
            get
            {
                return _waypoints;
            }
            set
            {
                if (_waypoints == value)
                    return;
                _waypoints = value;
            }
        }
        public GeoHelper()
        {
        }

        public GeoHelper(Waypoints waypoints)
        {
            _waypoints = waypoints;
        }

        public GeoHelper(Route route)
        {
            _route = route;
        }

        public string GetLineStringFromWaypoints(Waypoints waypoints)
        {
            var result = new StringBuilder();
            result.Append("LINESTRING(");

            bool first = true;
            foreach (var waypoint in waypoints.waypoint)
            {
                if (!first)
                    result.Append(",");
                else
                    first = false;

                result.Append(waypoint.position.lon.ToString(CultureInfo.InvariantCulture) + " " + waypoint.position.lat.ToString(CultureInfo.InvariantCulture));
            }

            result.Append(")");
            return result.ToString();
        }
    }
}
