﻿using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace SECOM.DataAccess.Entities
{
    public  class EncryptionKey : EntityBase
    {
        [Required]
        public byte[] Key { get; set; }

        [Required]
        public byte[] IV { get; set; }

        [Required]
        public Guid TransactionIdentifier { get; set; }

        [Required]
        public DigitalSignature DigitalSignature { get; set; }

        public bool SignatureValidatedOk { get; set; }

        [Required]
        public string EnvelopeSignatureCertificate { get; set; }

        [Required]
        public string EnvelopeRootCertificateThumbprint { get; set; }

        [Required]
        [DefaultValue(0)]
        public int EnvelopeSignatureHashType { get; set; }

        [Required]
        public string EnvelopeSignature { get; set; }

        [Required]
        public DateTime EnvelopeSignatureTime { get; set; }
    }
}