﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.DataAnnotations;

namespace SECOM.DataAccess.Entities
{
    public class SentMessage : EntityBase
    {
        [Required]
        public byte[] Data { get; set; }

        [Required]
        public int ContainerType { get; set; }

        [Required]
        public int DataProductType { get; set; }

        [Required]
        public virtual ExchangeMetadata ExchangeMetadata { get; set; }

        public bool AckReceived { get; set; }

        [Required]
        public Guid TransactionIdentifier { get; set; }

        public DateTime SentTime { get; set; }

        public bool? ToSubscription { get; set; }

        public string ReceiverMrn { get; set; }

        public bool SentAsLink { get; set; } = false;

        public DateTime? TimeToLive { get; set; }
    }
}
