﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace SECOM.DataAccess.Entities
{
    public class UploadedMessage : EntityBase
    {
        [Required]
        public byte[] Data { get; set; }

        [Required]
        public int ContainerType { get; set; }

        [Required]
        public int DataProductType { get; set; }

        [Required]
        public virtual ExchangeMetadata ExchangeMetadata { get; set; }

        [Required]
        public bool? FromSubscription { get; set; }

        public int AckRequest { get; set; }

        public string AckEndpoint { get; set; }

        public bool TechnicalAckDelivered { get; set; }

        public bool OperationalAckDelivered { get; set; }


        [Required]
        public Guid TransactionIdentifier { get; set; }

        public DateTime ReceivedTime { get; set; }

        public bool SignatureValidatedOk { get; set; }

        [Required]
        public string EnvelopeSignatureCertificate { get; set; }

        [Required]
        public string EnvelopeRootCertificateThumbprint { get; set; }

        [Required]
        [DefaultValue(0)]
        public int EnvelopeSignatureHashType { get; set; }

        [Required]
        public string EnvelopeSignature { get; set; }

        public DateTime EnvelopeSignatureTime { get; set; }

    }
}