﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace SECOM.DataAccess.Migrations
{
    public partial class InitialCreate : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "AckEnum",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Value = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AckEnum", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Acknowledgement",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    TransactionIdentifier = table.Column<Guid>(type: "uuid", nullable: false),
                    CreatedAt = table.Column<DateTime>(type: "timestamp without time zone", nullable: false),
                    AckType = table.Column<int>(type: "integer", nullable: false),
                    EnvelopeAckCertificate = table.Column<string>(type: "text", nullable: false),
                    EnvelopeRootCertificateThumbprint = table.Column<string>(type: "text", nullable: true),
                    EnvelopeSignatureTime = table.Column<DateTime>(type: "timestamp without time zone", nullable: false),
                    DigitalSignature = table.Column<string>(type: "text", nullable: true),
                    NackType = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Acknowledgement", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "AckRequestEnum",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Value = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AckRequestEnum", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Capability",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    DataProductType = table.Column<int>(type: "integer", nullable: false),
                    ProductSchemaUrl = table.Column<string>(type: "text", nullable: false),
                    ServiceVersion = table.Column<string>(type: "text", nullable: false),
                    ImplementsUpload = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsUploadLink = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsGet = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsGetByLink = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsGetSummary = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsSubscription = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsAccess = table.Column<bool>(type: "boolean", nullable: false),
                    ImplementsEncryptionKey = table.Column<bool>(type: "boolean", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Capability", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "ContainerTypeEnum",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Value = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ContainerTypeEnum", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "DataProductTypeEnum",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Value = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DataProductTypeEnum", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "DigitalSignature",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    PublicRootCertificateThumbprint = table.Column<string>(type: "text", nullable: true),
                    PublicCertificate = table.Column<string>(type: "text", nullable: false),
                    DigitalSignatureValue = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DigitalSignature", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Identity",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Name = table.Column<string>(type: "text", nullable: false),
                    Uid = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Identity", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "NackEnum",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Value = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_NackEnum", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Notification",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Body = table.Column<string>(type: "text", nullable: false),
                    Subject = table.Column<string>(type: "text", nullable: false),
                    ReceivedAt = table.Column<DateTime>(type: "timestamp without time zone", nullable: false),
                    TransactionId = table.Column<Guid>(type: "uuid", nullable: false),
                    Notified = table.Column<bool>(type: "boolean", nullable: false),
                    NotifiedAt = table.Column<DateTime>(type: "timestamp without time zone", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Notification", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "SECOM_ResponseCodeEnum",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Value = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SECOM_ResponseCodeEnum", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "TemporaryKey",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Key = table.Column<byte[]>(type: "bytea", nullable: false),
                    IV = table.Column<byte[]>(type: "bytea", nullable: false),
                    DataReference = table.Column<Guid>(type: "uuid", nullable: false),
                    PrivateCertificate = table.Column<byte[]>(type: "bytea", nullable: false),
                    Pwd = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TemporaryKey", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "EncryptionKey",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Key = table.Column<byte[]>(type: "bytea", nullable: false),
                    IV = table.Column<byte[]>(type: "bytea", nullable: false),
                    TransactionIdentifier = table.Column<Guid>(type: "uuid", nullable: false),
                    DigitalSignatureId = table.Column<int>(type: "integer", nullable: true),
                    SignatureValidatedOk = table.Column<bool>(type: "boolean", nullable: false),
                    EnvelopeSignatureCertificate = table.Column<string>(type: "text", nullable: false),
                    EnvelopeRootCertificateThumbprint = table.Column<string>(type: "text", nullable: false),
                    EnvelopeSignatureHashType = table.Column<int>(type: "integer", nullable: false),
                    EnvelopeSignature = table.Column<string>(type: "text", nullable: false),
                    EnvelopeSignatureTime = table.Column<DateTime>(type: "timestamp without time zone", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_EncryptionKey", x => x.Id);
                    table.ForeignKey(
                        name: "FK_EncryptionKey_DigitalSignature_DigitalSignatureId",
                        column: x => x.DigitalSignatureId,
                        principalTable: "DigitalSignature",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "ExchangeMetadata",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    DataProtection = table.Column<bool>(type: "boolean", nullable: false),
                    ProtectionScheme = table.Column<string>(type: "text", nullable: false),
                    DigitalSignatureReference = table.Column<string>(type: "text", nullable: false),
                    DigitalSignatureId = table.Column<int>(type: "integer", nullable: true),
                    CompressionFlag = table.Column<bool>(type: "boolean", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExchangeMetadata", x => x.Id);
                    table.ForeignKey(
                        name: "FK_ExchangeMetadata_DigitalSignature_DigitalSignatureId",
                        column: x => x.DigitalSignatureId,
                        principalTable: "DigitalSignature",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "PublishedMessage",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    CreatedTime = table.Column<DateTime>(type: "timestamp without time zone", nullable: false),
                    Data = table.Column<byte[]>(type: "bytea", nullable: false),
                    ContainerType = table.Column<int>(type: "integer", nullable: false),
                    DataReference = table.Column<Guid>(type: "uuid", nullable: false),
                    AckRequest = table.Column<int>(type: "integer", nullable: false),
                    DataProductTypeId = table.Column<int>(type: "integer", nullable: false),
                    ProductVersion = table.Column<string>(type: "text", nullable: true),
                    ExchangeMetadataId = table.Column<int>(type: "integer", nullable: true),
                    Geometry = table.Column<string>(type: "text", nullable: true),
                    Unlocode = table.Column<string>(type: "text", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PublishedMessage", x => x.Id);
                    table.ForeignKey(
                        name: "FK_PublishedMessage_ExchangeMetadata_ExchangeMetadataId",
                        column: x => x.ExchangeMetadataId,
                        principalTable: "ExchangeMetadata",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "SentMessage",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Data = table.Column<byte[]>(type: "bytea", nullable: false),
                    ContainerType = table.Column<int>(type: "integer", nullable: false),
                    DataProductType = table.Column<int>(type: "integer", nullable: false),
                    ExchangeMetadataId = table.Column<int>(type: "integer", nullable: true),
                    AckReceived = table.Column<bool>(type: "boolean", nullable: false),
                    TransactionIdentifier = table.Column<Guid>(type: "uuid", nullable: false),
                    SentTime = table.Column<DateTime>(type: "timestamp without time zone", nullable: false),
                    ToSubscription = table.Column<bool>(type: "boolean", nullable: true),
                    ReceiverMrn = table.Column<string>(type: "text", nullable: true),
                    SentAsLink = table.Column<bool>(type: "boolean", nullable: false),
                    TimeToLive = table.Column<DateTime>(type: "timestamp without time zone", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SentMessage", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SentMessage_ExchangeMetadata_ExchangeMetadataId",
                        column: x => x.ExchangeMetadataId,
                        principalTable: "ExchangeMetadata",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "UploadedMessage",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Data = table.Column<byte[]>(type: "bytea", nullable: false),
                    ContainerType = table.Column<int>(type: "integer", nullable: false),
                    DataProductType = table.Column<int>(type: "integer", nullable: false),
                    ExchangeMetadataId = table.Column<int>(type: "integer", nullable: true),
                    FromSubscription = table.Column<bool>(type: "boolean", nullable: false),
                    AckRequest = table.Column<int>(type: "integer", nullable: false),
                    AckEndpoint = table.Column<string>(type: "text", nullable: true),
                    TechnicalAckDelivered = table.Column<bool>(type: "boolean", nullable: false),
                    OperationalAckDelivered = table.Column<bool>(type: "boolean", nullable: false),
                    TransactionIdentifier = table.Column<Guid>(type: "uuid", nullable: false),
                    ReceivedTime = table.Column<DateTime>(type: "timestamp without time zone", nullable: false),
                    SignatureValidatedOk = table.Column<bool>(type: "boolean", nullable: false),
                    EnvelopeSignatureCertificate = table.Column<string>(type: "text", nullable: false),
                    EnvelopeRootCertificateThumbprint = table.Column<string>(type: "text", nullable: false),
                    EnvelopeSignatureHashType = table.Column<int>(type: "integer", nullable: false),
                    EnvelopeSignature = table.Column<string>(type: "text", nullable: false),
                    EnvelopeSignatureTime = table.Column<DateTime>(type: "timestamp without time zone", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UploadedMessage", x => x.Id);
                    table.ForeignKey(
                        name: "FK_UploadedMessage_ExchangeMetadata_ExchangeMetadataId",
                        column: x => x.ExchangeMetadataId,
                        principalTable: "ExchangeMetadata",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "IdentityAcl",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    IdentityId = table.Column<int>(type: "integer", nullable: false),
                    MessageId = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_IdentityAcl", x => x.Id);
                    table.ForeignKey(
                        name: "FK_IdentityAcl_Identity_IdentityId",
                        column: x => x.IdentityId,
                        principalTable: "Identity",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_IdentityAcl_PublishedMessage_MessageId",
                        column: x => x.MessageId,
                        principalTable: "PublishedMessage",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.InsertData(
                table: "AckEnum",
                columns: new[] { "Id", "Value" },
                values: new object[,]
                {
                    { 0, "Delivered" },
                    { 1, "Opened" },
                    { 2, "Error" }
                });

            migrationBuilder.InsertData(
                table: "AckRequestEnum",
                columns: new[] { "Id", "Value" },
                values: new object[,]
                {
                    { 0, "No ACK requested" },
                    { 1, "Delivered ACK requested" },
                    { 2, "Opened ACK requested" },
                    { 3, "Delivered + Opened ACK requested" }
                });

            migrationBuilder.InsertData(
                table: "Capability",
                columns: new[] { "Id", "DataProductType", "ImplementsAccess", "ImplementsEncryptionKey", "ImplementsGet", "ImplementsGetByLink", "ImplementsGetSummary", "ImplementsSubscription", "ImplementsUpload", "ImplementsUploadLink", "ProductSchemaUrl", "ServiceVersion" },
                values: new object[,]
                {
                    { 5, 8, false, true, false, false, false, false, true, true, "http://iho.com/S-124/1/0/0", "1.0" },
                    { 3, 24, true, true, true, true, true, true, true, true, "http://cirm.org/rtz/RTZ%20Schema%20version%201_2.xsd", "1.0" },
                    { 4, 23, true, true, true, true, true, true, true, true, "http://iho.com/S-421/1/0/0", "1.0" },
                    { 1, 24, true, true, true, true, true, true, true, true, "http://cirm.org/rtz/RTZ%20Schema%20version%201_0.xsd", "1.0" },
                    { 2, 24, true, true, true, true, true, true, true, true, "http://cirm.org/rtz/RTZ%20Schema%20version%201_1.xsd", "1.0" }
                });

            migrationBuilder.InsertData(
                table: "ContainerTypeEnum",
                columns: new[] { "Id", "Value" },
                values: new object[,]
                {
                    { 0, "S100_DATASET" },
                    { 1, "S100_EXCHANGESET" },
                    { 2, "NONE" }
                });

            migrationBuilder.InsertData(
                table: "DataProductTypeEnum",
                columns: new[] { "Id", "Value" },
                values: new object[,]
                {
                    { 15, "S211" },
                    { 10, "S126" },
                    { 11, "S127" },
                    { 12, "S128" },
                    { 13, "S129" },
                    { 14, "S210" },
                    { 16, "S212" },
                    { 23, "S421" },
                    { 18, "S402" },
                    { 19, "S411" },
                    { 20, "S412" },
                    { 21, "S413" },
                    { 22, "S414" },
                    { 9, "S125" },
                    { 17, "S401" },
                    { 8, "S124" },
                    { 1, "S57" },
                    { 6, "S122" },
                    { 7, "S123" },
                    { 24, "RTZ" },
                    { 2, "S101" },
                    { 25, "EPC" },
                    { 4, "S104" },
                    { 5, "S111" },
                    { 3, "S102" }
                });

            migrationBuilder.InsertData(
                table: "NackEnum",
                columns: new[] { "Id", "Value" },
                values: new object[,]
                {
                    { 4, "Failed decompression" },
                    { 3, "Failed decryption" },
                    { 2, "Failed signature verification" },
                    { 1, "Unknown data type or version" },
                    { 0, "XML Schema validation error" }
                });

            migrationBuilder.InsertData(
                table: "SECOM_ResponseCodeEnum",
                columns: new[] { "Id", "Value" },
                values: new object[,]
                {
                    { 3, "Schema validation error" },
                    { 2, "Invalid certificate" },
                    { 0, "Missing required data for the service" },
                    { 1, "Failed signature verification" }
                });

            migrationBuilder.CreateIndex(
                name: "IX_EncryptionKey_DigitalSignatureId",
                table: "EncryptionKey",
                column: "DigitalSignatureId");

            migrationBuilder.CreateIndex(
                name: "IX_ExchangeMetadata_DigitalSignatureId",
                table: "ExchangeMetadata",
                column: "DigitalSignatureId");

            migrationBuilder.CreateIndex(
                name: "IX_IdentityAcl_IdentityId",
                table: "IdentityAcl",
                column: "IdentityId");

            migrationBuilder.CreateIndex(
                name: "IX_IdentityAcl_MessageId",
                table: "IdentityAcl",
                column: "MessageId");

            migrationBuilder.CreateIndex(
                name: "IX_PublishedMessage_ExchangeMetadataId",
                table: "PublishedMessage",
                column: "ExchangeMetadataId");

            migrationBuilder.CreateIndex(
                name: "IX_SentMessage_ExchangeMetadataId",
                table: "SentMessage",
                column: "ExchangeMetadataId");

            migrationBuilder.CreateIndex(
                name: "IX_UploadedMessage_ExchangeMetadataId",
                table: "UploadedMessage",
                column: "ExchangeMetadataId");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "AckEnum");

            migrationBuilder.DropTable(
                name: "Acknowledgement");

            migrationBuilder.DropTable(
                name: "AckRequestEnum");

            migrationBuilder.DropTable(
                name: "Capability");

            migrationBuilder.DropTable(
                name: "ContainerTypeEnum");

            migrationBuilder.DropTable(
                name: "DataProductTypeEnum");

            migrationBuilder.DropTable(
                name: "EncryptionKey");

            migrationBuilder.DropTable(
                name: "IdentityAcl");

            migrationBuilder.DropTable(
                name: "NackEnum");

            migrationBuilder.DropTable(
                name: "Notification");

            migrationBuilder.DropTable(
                name: "SECOM_ResponseCodeEnum");

            migrationBuilder.DropTable(
                name: "SentMessage");

            migrationBuilder.DropTable(
                name: "TemporaryKey");

            migrationBuilder.DropTable(
                name: "UploadedMessage");

            migrationBuilder.DropTable(
                name: "Identity");

            migrationBuilder.DropTable(
                name: "PublishedMessage");

            migrationBuilder.DropTable(
                name: "ExchangeMetadata");

            migrationBuilder.DropTable(
                name: "DigitalSignature");
        }
    }
}
