﻿using SECOM.Module.Ui.ViewModels;
using SECOM.Module.Ui.Views;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SECOM.Module.Ui
{
    public partial class MainWindow : Window
    {
        public readonly SettingsView _settingsView;
        public readonly PublishedMessageView _publishedMessageView;
        public readonly UploadedMessageView _uploadedMessageView;
        public readonly FindServicesView _findServicesView;

        public MainWindow(MainViewModel viewModel, 
            SettingsView settingsView,
            PublishedMessageView publishedMessageView,
            UploadedMessageView uploadedMessageView,
            FindServicesView findServicesView)
        {
            InitializeComponent();
            DataContext = viewModel;
            _settingsView = settingsView;
            _publishedMessageView = publishedMessageView;
            _uploadedMessageView = uploadedMessageView;
            _findServicesView = findServicesView;

            Application.Current.DispatcherUnhandledException += Current_DispatcherUnhandledException;
        }

        public PublishedMessageView PublishedMessageView
        {
            get { return _publishedMessageView; }
        }

        public UploadedMessageView UploadedMessageView
        {
            get { return _uploadedMessageView; }
        }

        public SettingsView SettingsView
        {
            get { return _settingsView; }
        }

        public FindServicesView FindServicesView
        {
            get { return _findServicesView; }
        }

        private void Current_DispatcherUnhandledException(object sender, System.Windows.Threading.DispatcherUnhandledExceptionEventArgs e)
        {
            MessageBox.Show(e.Exception.Message);
            e.Handled = true;
        }

        public MainViewModel ViewModel
        {
            get
            {
                return DataContext as MainViewModel;
            }
        }
    }
}
