﻿using SECOM.Module.Ui.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SECOM.Module.Ui.ViewModels
{
    public class GetSummaryViewModel : ViewModelBase
    {
        public GetSummaryViewModel()
        {
            DataProductTypes = new List<ComboBoxData>();
            DataProductTypes.Add(new ComboBoxData { Text = "S57", Value = 0 });
            DataProductTypes.Add(new ComboBoxData { Text = "S101", Value = 1 });
            DataProductTypes.Add(new ComboBoxData { Text = "S102", Value = 2 });
            DataProductTypes.Add(new ComboBoxData { Text = "S104", Value = 3 });
            DataProductTypes.Add(new ComboBoxData { Text = "S111", Value = 4 });
            DataProductTypes.Add(new ComboBoxData { Text = "S122", Value = 5 });
            DataProductTypes.Add(new ComboBoxData { Text = "S123", Value = 6 });
            DataProductTypes.Add(new ComboBoxData { Text = "S124", Value = 7 });
            DataProductTypes.Add(new ComboBoxData { Text = "S125", Value = 8 });
            DataProductTypes.Add(new ComboBoxData { Text = "S126", Value = 9 });
            DataProductTypes.Add(new ComboBoxData { Text = "S127", Value = 10 });
            DataProductTypes.Add(new ComboBoxData { Text = "S128", Value = 11 });
            DataProductTypes.Add(new ComboBoxData { Text = "S129", Value = 12 });
            DataProductTypes.Add(new ComboBoxData { Text = "S210", Value = 13 });
            DataProductTypes.Add(new ComboBoxData { Text = "S211", Value = 14 });
            DataProductTypes.Add(new ComboBoxData { Text = "S212", Value = 15 });
            DataProductTypes.Add(new ComboBoxData { Text = "S401", Value = 16 });
            DataProductTypes.Add(new ComboBoxData { Text = "S402", Value = 17 });
            DataProductTypes.Add(new ComboBoxData { Text = "S411", Value = 18 });
            DataProductTypes.Add(new ComboBoxData { Text = "S412", Value = 19 });
            DataProductTypes.Add(new ComboBoxData { Text = "S413", Value = 20 });
            DataProductTypes.Add(new ComboBoxData { Text = "S414", Value = 21 });
            DataProductTypes.Add(new ComboBoxData { Text = "S421", Value = 22 });
            DataProductTypes.Add(new ComboBoxData { Text = "RTZ", Value = 23 });
            DataProductTypes.Add(new ComboBoxData { Text = "EPC", Value = 24 });
            DataProductTypes.Add(new ComboBoxData { Text = "OTHER", Value = 25 });

            ContainerTypes = new List<Models.ComboBoxData>();
            ContainerTypes.Add(new Models.ComboBoxData { Text = "S100 DataSet", Value = 0 });
            ContainerTypes.Add(new Models.ComboBoxData { Text = "S100 ExchangeSet", Value = 1 });
            ContainerTypes.Add(new Models.ComboBoxData { Text = "NONE", Value = 2 });

        }

        public List<Models.ComboBoxData> ContainerTypes { get; }

        public List<Models.ComboBoxData> DataProductTypes { get; }

        private string _dataReference;
        public string DataReference
        {
            get
            {
                return _dataReference;
            }
            set
            {
                if (_dataReference == value)
                    return;
                _dataReference = value;

                OnPropertyChanged(() => DataReference);
            }
        }

        private int? _containerType = null;
        public int? ContainerType
        {
            get
            {
                return _containerType;
            }
            set
            {
                if (_containerType == value)
                    return;
                _containerType = value;

                OnPropertyChanged(() => ContainerType);
            }
        }

        private int? _dataProducType = null;
        public int? DataProductType
        {
            get
            {
                return _dataProducType;
            }
            set
            {
                if (_dataProducType == value)
                    return;
                _dataProducType = value;

                OnPropertyChanged(() => DataProductType);
            }
        }

        private string _productVersion;
        public string ProductVersion
        {
            get
            {
                return _productVersion;
            }
            set
            {
                if (_productVersion == value)
                    return;
                _productVersion = value;

                OnPropertyChanged(() => ProductVersion);
            }
        }

        private string _geometry;
        public string Geometry
        {
            get
            {
                return _geometry;
            }
            set
            {
                if (_geometry == value)
                    return;
                _geometry = value;

                OnPropertyChanged(() => Geometry);
            }
        }

        private string _unlocode;
        public string Unlocode
        {
            get
            {
                return _unlocode;
            }
            set
            {
                if (_unlocode == value)
                    return;
                _unlocode = value;

                OnPropertyChanged(() => Unlocode);
            }
        }

        private DateTime? _fromTime;
        public DateTime? FromTime
        {
            get
            {
                return _fromTime;
            }
            set
            {
                if (_fromTime == value)
                    return;
                _fromTime = value;

                OnPropertyChanged(() => FromTime);
            }
        }

        private DateTime? _toTime;
        public DateTime? ToTime
        {
            get
            {
                return _toTime;
            }
            set
            {
                if (_toTime == value)
                    return;
                _toTime = value;

                OnPropertyChanged(() => ToTime);
            }
        }

        private int _page = 1;
        public int Page
        {
            get
            {
                return _page;
            }
            set
            {
                if (_page == value)
                    return;
                _page = value;

                OnPropertyChanged(() => Page);
            }
        }

        private int _pageSize = 3;
        public int PageSize
        {
            get
            {
                return _pageSize;
            }
            set
            {
                if (_pageSize == value)
                    return;
                _pageSize = value;

                OnPropertyChanged(() => PageSize);
            }
        }
    }
}
