﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Threading.Tasks;

namespace SECOM.Pki.Models
{
    /// <summary>
    /// The reason the certificates has been revoked
    /// </summary>
    /// <value>The reason the certificates has been revoked</value>
    public enum RevocationReasonEnum
    {
        /// <summary>
        /// Enum UnspecifiedEnum for unspecified
        /// </summary>
        [EnumMember(Value = "unspecified")]
        UnspecifiedEnum = 1,

        /// <summary>
        /// Enum KeycompromiseEnum for keycompromise
        /// </summary>
        [EnumMember(Value = "keycompromise")]
        KeycompromiseEnum = 2,

        /// <summary>
        /// Enum CacompromiseEnum for cacompromise
        /// </summary>
        [EnumMember(Value = "cacompromise")]
        CacompromiseEnum = 3,

        /// <summary>
        /// Enum AffiliationchangedEnum for affiliationchanged
        /// </summary>
        [EnumMember(Value = "affiliationchanged")]
        AffiliationchangedEnum = 4,

        /// <summary>
        /// Enum SupersededEnum for superseded
        /// </summary>
        [EnumMember(Value = "superseded")]
        SupersededEnum = 5,

        /// <summary>
        /// Enum CessationofoperationEnum for cessationofoperation
        /// </summary>
        [EnumMember(Value = "cessationofoperation")]
        CessationofoperationEnum = 6,

        /// <summary>
        /// Enum CertificateholdEnum for certificatehold
        /// </summary>
        [EnumMember(Value = "certificatehold")]
        CertificateholdEnum = 7,

        /// <summary>
        /// Enum RemovefromcrlEnum for removefromcrl
        /// </summary>
        [EnumMember(Value = "removefromcrl")]
        RemovefromcrlEnum = 8,

        /// <summary>
        /// Enum PrivilegewithdrawnEnum for privilegewithdrawn
        /// </summary>
        [EnumMember(Value = "privilegewithdrawn")]
        PrivilegewithdrawnEnum = 9,

        /// <summary>
        /// Enum AacompromiseEnum for aacompromise
        /// </summary>
        [EnumMember(Value = "aacompromise")]
        AacompromiseEnum = 10
    }
}