﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using SECOM.Common.Integration.Models;
using SECOM.Common.Models.Private;
using SECOM.Common.Services;
using IConfiguration = Microsoft.Extensions.Configuration.IConfiguration;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Configuration;

namespace SECOM.Service.Private.Rest.v1
{
    [Route("v1/[controller]")]
    [ApiController]
    public class IdentityRegistryController : ControllerBase
    {
        private readonly ILogger _logger;
        private readonly IIdentityRegistryService _identityRegistryService;
        private readonly IConfiguration _configuration;

        public IdentityRegistryController(ILogger<IdentityRegistryService> logger, IIdentityRegistryService identityRegistryService, IConfiguration configuration)
        {
            _logger = logger;
            _identityRegistryService = identityRegistryService;
            _configuration = configuration;
        }

        [HttpGet]
        [Route("Find")]
        public async Task<IdRegistryResponeObject> Find()
        {
            return await _identityRegistryService.FindIdentities();
        }

    }
}
