﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Filters;
using Microsoft.AspNetCore.Server.IIS;
using SECOM.Common.Models.Public;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Threading.Tasks;

namespace SECOM.Service.Public.Filters
{
    public class HandleExceptionAttribute : ExceptionFilterAttribute
    {
        public override void OnException(ExceptionContext context)
        {
            var code = HttpStatusCode.InternalServerError;
            var exception = context.Exception;

            if (exception.Message == "Request entity too large.")
            {
                code = HttpStatusCode.RequestEntityTooLarge;
            }

            var response = new UploadResponseObject
            {
                Message = $"{exception.Message}"
            };

            context.HttpContext.Response.StatusCode = (int)code;
            context.Result = new JsonResult(response);
        }

    }
}
