﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Threading.Tasks;

namespace SECOM.ServiceDiscovery.Models
{
    [DataContract]
    public class SearchServiceParameters
    {
        /// <summary>
        /// Gets or Sets Name from S-100 Service Model
        /// </summary>
        [DataMember(Name = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets Status from S-100 Service Model
        /// </summary>
        [DataMember(Name = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or Sets Version from S-100 Service Model
        /// </summary>
        [DataMember(Name = "version")]
        public string Version { get; set; }

        /// <summary>
        /// Gets or Sets Keywords from S-100 Service Model
        /// </summary>
        [DataMember(Name = "keywords")]
        public List<string> Keywords { get; set; }

        /// <summary>
        /// Gets or Sets Description from S-100 Service Model
        /// </summary>
        [DataMember(Name = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets SpecificationId MRN from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "specificationId")]
        public string SpecificationId { get; set; }

        /// <summary>
        /// Gets or Sets DesignId MRN from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "designId")]
        public string DesignId { get; set; }

        /// <summary>
        /// Gets or Sets InstanceId MRN from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "instanceId")]
        public string InstanceId { get; set; }

        /// <summary>
        /// Gets or Sets Mmsi from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "mmsi")]
        public string Mmsi { get; set; }

        /// <summary>
        /// Gets or Sets Imo from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "imo")]
        public string Imo { get; set; }

        /// <summary>
        /// Gets or Sets ServiceType from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "serviceType")]
        public string ServiceType { get; set; }

        /// <summary>
        /// Gets or Sets Unlocode from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "unlocode")]
        public string Unlocode { get; set; }

        /// <summary>
        /// Gets or Sets EndpointUri from IALA Service Model G1128 
        /// </summary>
        [DataMember(Name = "endpointUri")]
        public string EndpointUri { get; set; }

        /// <summary>
        /// Gets or Sets DataProductType from SECOM S100_DataProductType 
        /// </summary>
        [DataMember(Name = "dataProductType")]
        public string DataProductType { get; set; }

        /// <summary>
        /// Gets or Sets Page
        /// </summary>
        [DataMember(Name = "page")]
        public long? Page { get; set; }

        /// <summary>
        /// Gets or Sets PageSize
        /// </summary>
        [DataMember(Name = "pageSize")]
        public long? PageSize { get; set; }

    }
}
