﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Threading.Tasks;

namespace SECOM.ServiceDiscovery.Models
{
    [DataContract]
    public class SearchServiceRequest
    {
        /// <summary>
        /// Gets or Sets Query
        /// </summary>
        [DataMember(Name ="query")]
        public SearchServiceParameters Query { get; set; }

        /// <summary>
        /// Gets or sets Geometry WKT
        /// </summary>
        [DataMember(Name ="geometry")]
        public string Geometry { get; set; }

        /// <summary>
        /// Gets or sets FreeText
        /// </summary>
        [DataMember(Name ="freetext")]
        public string FreeText { get; set; }

        /// <summary>
        /// Gets or sets includeXml, default = false
        /// </summary>
        [DataMember(Name = "includeXml")]
        [DefaultValue(false)]
        public bool? IncludeXml { get; set; }
    }
}
