using System.Runtime.Serialization;

namespace SECOM.ServiceDiscovery.Models
{
    /// <summary>
    /// A technical way to describe aspects if a service.The Xml should validate against a XSD from a SpecificationTemplate.
    /// </summary>
    [DataContract]
    public partial class Xml
    {
        public Xml()
        {}

        /// <summary>
        /// Initializes a new instance of the <see cref="Xml" /> class.
        /// </summary>
        /// <param name="Comment">Comment.</param>
        /// <param name="Content">Content.</param>
        /// <param name="ContentContentType">ContentContentType.</param>
        /// <param name="Id">Id.</param>
        /// <param name="Name">Name.</param>
        public Xml(string Comment = null, string Content = null, string ContentContentType = null, long? Id = null, string Name = null)
        {
            this.Comment = Comment;
            this.Content = Content;
            this.ContentContentType = ContentContentType;
            this.Id = Id;
            this.Name = Name;
            
        }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name="comment")]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets Content
        /// </summary>
        [DataMember(Name="content")]
        public string Content { get; set; }

        /// <summary>
        /// Gets or Sets ContentContentType
        /// </summary>
        [DataMember(Name="contentContentType")]
        public string ContentContentType { get; set; }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id")]
        public long? Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name")]
        public string Name { get; set; }

    }
}
